SystemOrganization addCategory: #'HEB-Tarea2'!
SystemOrganization addCategory: #'HEB-Tarea2-Test'!

Object subclass: #EdgesMethod
	instanceVariableNames: 'points beta edgeCuts fun'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HEB-Tarea2'!

!EdgesMethod methodsFor: 'accessing' stamp: 'Aldo 12/19/2011 02:01'!
getBeta
	^ beta.! !

!EdgesMethod methodsFor: 'accessing' stamp: 'Aldo 12/19/2011 14:24'!
getEdgeCuts
	^ edgeCuts.! !

!EdgesMethod methodsFor: 'accessing' stamp: 'Aldo 12/19/2011 15:02'!
getPoints
	^ points.! !

!EdgesMethod methodsFor: 'initialization' stamp: 'Aldo 12/21/2011 17:41'!
initialize: nodes

	points := nodes collect:  #position.
	beta := 1.
	edgeCuts := 5.
	fun := OriginalSFunction new.
	fun initialize: points and: beta. 
	! !

!EdgesMethod methodsFor: 'initialization' stamp: 'Aldo 12/21/2011 17:43'!
initialize: nodes with: aDouble.

	points := nodes collect:  #position.
	beta := aDouble.
	edgeCuts := 5.
	fun := NewSFunction new.
	fun initialize: points and: beta. ! !

!EdgesMethod methodsFor: 'accessing' stamp: 'Aldo 12/19/2011 02:01'!
setBeta: aDouble 
	beta := aDouble.! !

!EdgesMethod methodsFor: 'accessing' stamp: 'Aldo 12/19/2011 19:13'!
setEdgeCuts: aDouble
	edgeCuts := aDouble.! !

!EdgesMethod methodsFor: 'as yet unclassified' stamp: 'Aldo 12/21/2011 17:44'!
straightEdgeBetween: i and: j
	
	| pi pj retVals edMeth cutValue |
	
	retVals := OrderedCollection new.

	cutValue := 1/edgeCuts.

	(1 to: edgeCuts) do: [:k | retVals add: (fun s: (k*edgeCuts) at: i and: j) ].! !

Object subclass: #HEBTree
	instanceVariableNames: 'numberOfNodes hebNodes hierarchyMatrix relationMatrix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HEB-Tarea2'!

!HEBTree methodsFor: 'accessing' stamp: 'Aldo 12/14/2011 15:08'!
getNodes
	^ hebNodes.! !

!HEBTree methodsFor: 'initialization' stamp: 'Aldo 12/14/2011 15:06'!
initialize: nds with: hierAdj and: relAdj
	"
	Initializes the HEB Tree by giving it:
		* nds: the nodes (an array of points)
		* hierAdj: the adjacency matrix asotiated with the tree hierarchy
		* relAdj: the adjacency matrix asotiated with the other relation 
	"
	hebNodes := nds.
	numberOfNodes := hebNodes size.
	hierarchyMatrix := hierAdj.
	relationMatrix := relAdj.! !

Object subclass: #NewSFunction
	instanceVariableNames: 'points beta n sFunction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HEB-Tarea2'!

!NewSFunction methodsFor: 'initialization' stamp: 'Aldo 12/21/2011 17:47'!
initialize: aCollectionOfPoints and: aDouble

	points := aCollectionOfPoints.
	n := points size.
	beta := aDouble.
	sFunction := OriginalSFunction new.
	sFunction initialize: points and: beta.! !

!NewSFunction methodsFor: 'as yet unclassified' stamp: 'Aldo 12/21/2011 18:04'!
s: t at: i and: j
	|sx  sy s0 sx0 sy0 p1 pN x1 y1 xN yN|
	
	s0 := sFunction s: t at:i and: j.
	sx0 := s0 x.
	sy0 := s0 y.
	
	p1 := points at: i.
	pN := points at: j.
	
	x1 := p1 x.
	y1 := p1 y.
	
	xN := pN x.
	yN := pN y.
	
	sx := (beta * sx0) + ((1 - beta)*(x1 + (t * (xN-x1)))).
	sy := (beta * sy0) + ((1 - beta)*(y1 + (t * (yN-y1)))).

	"sFunction := self."
	
	^ sx @ sy.! !

Object subclass: #OriginalSFunction
	instanceVariableNames: 'points beta n sFunction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HEB-Tarea2'!

!OriginalSFunction methodsFor: 'initialization' stamp: 'Aldo 12/21/2011 17:48'!
initialize: aCollectionOfPoints and: aDouble

	points := aCollectionOfPoints.
	n := points size.
	beta := aDouble.
	sFunction := nil.! !

!OriginalSFunction methodsFor: 'as yet unclassified' stamp: 'Aldo 12/21/2011 17:39'!
s: t at: i and: j
	" 
	Simple spline function 
	
	t is in [0,1]
	
	s: 0 returns p1 := (x1@y1)
	s: 1 returns pN := (xN@yN)
	
	"
	|p1 pN sx sy x1 xN y1 yN|
	p1 := points at: i.
	pN := points at: j.
	
	x1 := p1 x.
	y1 := p1 y.

	xN := pN x.
	yN := pN y.
	
	sx := (xN-x1)*t + x1.
	sy := (yN-y1)*t + y1.
	
	^ sx@sy.! !

Object subclass: #PointsMethod
	instanceVariableNames: 'points beta n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HEB-Tarea2'!

!PointsMethod methodsFor: 'as yet unclassified' stamp: 'Aldo 12/15/2011 12:21'!
getControlPointAtIndex: i
	
	" 
	P_{i}' = B * P_{i} + (1 - B)(P_{0} + (i/N-1)(P_{N-1} - P_{0}))  
	
	0 to: N-1 -> 1 to: N	
	"
	
	
	^ (beta * (points at: i)) + (1 - beta) * ((points at: 1) + ((i / (n-1) * ((points at:n) - (points at: 1))))).! !

!PointsMethod methodsFor: 'initialization' stamp: 'Aldo 12/14/2011 15:13'!
initialize: anArrayOfPoints and: aDouble

	points := anArrayOfPoints.
	n := points size.
	beta := aDouble.! !

TestCase subclass: #TestEdgesMethod
	instanceVariableNames: 'edgesMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HEB-Tarea2-Test'!

!TestEdgesMethod methodsFor: 'running' stamp: 'Aldo 12/21/2011 18:12'!
setUp

	| nodes points view beta |
	view := MOViewRenderer new.
	nodes := view nodes: (1 to: 20).
	beta := 0.5.
	
	edgesMethod := EdgesMethod new.
	edgesMethod initialize: nodes with: beta.
	! !

!TestEdgesMethod methodsFor: 'tests' stamp: 'Aldo 12/19/2011 19:01'!
testGetBeta
	| value |
	value := 0.1.
	edgesMethod setBeta: value.
	self assert: ((edgesMethod getBeta) == value)! !

!TestEdgesMethod methodsFor: 'tests' stamp: 'Aldo 12/19/2011 19:14'!
testGetEdgeCuts
	| value |
	value := 20.
	edgesMethod setEdgeCuts: value.
	self assert: ((edgesMethod getEdgeCuts) == value).! !

!TestEdgesMethod methodsFor: 'as yet unclassified' stamp: 'Aldo 12/21/2011 18:13'!
testGetPoints

	| points p1 |
	points := edgesMethod getPoints.
	
	p1 points at: 1.
	! !

!TestEdgesMethod methodsFor: 'as yet unclassified' stamp: 'Aldo 12/21/2011 18:12'!
testStraightEdgeBetween

	| result getA |
	result := edgesMethod straightEdgeBetween: 1 and: 3.! !

TestCase subclass: #TestNewSFunction
	instanceVariableNames: 'newSFunction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HEB-Tarea2-Test'!

!TestNewSFunction methodsFor: 'as yet unclassified' stamp: 'Aldo 12/21/2011 17:55'!
setUp 
	
	| aCollectionOfPoints aDouble |	
	aCollectionOfPoints := OrderedCollection new.
	aCollectionOfPoints add: 100@100.
	aCollectionOfPoints add: 300@300.
	aCollectionOfPoints add: 500@500.
	aCollectionOfPoints add: 800@800.
	aDouble := 0.4.

	newSFunction := NewSFunction new.
	newSFunction initialize: aCollectionOfPoints and: aDouble.! !

!TestNewSFunction methodsFor: 'as yet unclassified' stamp: 'Aldo 12/21/2011 18:07'!
testS
	| t i j result |
	t := 0.1.
	i := 1.
	j := 3.
	
	result := newSFunction s: t at: i and: j.
	Transcript show: result.

	self assert: (result x) = 140.0.
	self assert: (result y) = 140.0.! !
